/*
 * fmi_sequence_index.h
 *
 *  Created on: 2011/02/28
 *      Author: shu
 */

#ifndef FMI_SEQUENCE_INDEX_H_
#define FMI_SEQUENCE_INDEX_H_

#include <fstream>
#include "sequence_index.h"
#include "fm_index.h"

class Encoder;

class FmiSequenceIndex : public SequenceIndex {
public:
  FmiSequenceIndex(const unsigned char *text, unsigned int length, unsigned int log_interval, const Encoder &encoder);
  FmiSequenceIndex(ifstream &is);
  virtual ~FmiSequenceIndex();

  void Search(unsigned int offset, unsigned int start, unsigned int end, unsigned char *start_character, unsigned char *end_character,
      unsigned int *start_list, unsigned int *end_list);
  unsigned int Locate(unsigned int position);
  unsigned int GetMaxAlphabet();

  void Load(ifstream &is);
  void Save(ofstream &os);

private:
  FmIndex index_;
};

#endif /* FMI_SEQUENCE_INDEX_H_ */
